Attribute VB_Name = "basUserColumnSetup"
Option Explicit
Public Sub LoadUserColumnSetup_Queries(ByRef qdf As DAO.QueryDef)
    Dim fld As DAO.Field
    Dim strBlob As String
    Dim strColumns() As String
    Dim intColumns As Integer
    Dim intColumn As Integer
    Dim strValues() As String
    
    On Error Resume Next
    
    
    
    strBlob = GetSetting("DB_Datasheet_Settings", "Settings", qdf.Name, "")

    If strBlob <> "" Then
      Call GetOrderedColumns(strBlob, strColumns)
    
      intColumns = UBound(strColumns) + 1
      If intColumns <> 0 Then
        For intColumn = 0 To intColumns - 1
          If Trim(strColumns(intColumn)) <> "" Then
             strValues = Split(strColumns(intColumn), ":")
             Set fld = qdf.Fields(strValues(0))
             Call SetDAOFieldProperty(fld, "ColumnOrder", CInt(strValues(1)), dbInteger)  'ctl.ColumnOrder = CInt(strValues(1))
             Call SetDAOFieldProperty(fld, "ColumnHidden", CInt(strValues(2)), dbInteger)  'ctl.ColumnHidden = CBool(strValues(2))
             Call SetDAOFieldProperty(fld, "ColumnWidth", CInt(strValues(3)), dbInteger)  'ctl.ColumnWidth = CLng(strValues(3))
          End If
        Next
      End If
    End If

End Sub
Private Sub GetOrderedColumns(ByVal strData As String, _
                              ByRef strColumns() As String)
    Dim strTemp() As String
    Dim intCols As Integer
    Dim intCol As Integer
    Dim intCurr As Integer
    Dim strValues() As String
    
    On Error Resume Next

    strTemp = Split(strData, vbCrLf)
    intCols = UBound(strTemp) - 1
    
    ReDim strColumns(intCols)
    For intCol = 0 To intCols
        For intCurr = 0 To intCols
            strValues = Split(strTemp(intCurr), ":")
            If CInt(strValues(1)) = intCol + 1 Then
                strColumns(intCol) = strTemp(intCurr)
                Exit For
            End If
        Next
    Next
    
End Sub
Private Sub SetDAOFieldProperty _
               (fld As DAO.Field, _
 stName As String, vValue As Variant, _
               lType As Long)
    Dim prp As DAO.Property
 On Error Resume Next
    For Each prp In fld.Properties
        If StrComp(prp.Name, stName, _
         vbBinaryCompare) = 0 Then
            prp.Value = vValue
            Exit For
        End If
        Set prp = Nothing
    Next prp
    
    If prp Is Nothing Then
        Set prp = fld.CreateProperty(stName, _
         lType, vValue)
        fld.Properties.Append prp
    End If
End Sub
Public Sub SaveUserColumnSetup_Queries(ByRef qdf As DAO.QueryDef)
    Dim fld As Field
    Dim strBlob As String
    Dim strCtl As String
    Dim prt As DAO.Property
    On Error Resume Next

  strBlob = ""
    
    For Each fld In qdf.Fields
   
    Set prt = fld.CreateProperty("ColumnWidth", DAO.DataTypeEnum.dbInteger, -2)
    fld.Properties.Append prt
          strCtl = fld.Name & ":" & _
                   fld.Properties("ColumnOrder") & ":" & _
                   fld.Properties("ColumnHidden") & ":" & _
                   fld.Properties("ColumnWidth") & vbCrLf
          strBlob = strBlob & strCtl
    
    Next
    
    
    SaveSetting "DB_Datasheet_Settings", "Settings", qdf.Name, strBlob

End Sub
Public Sub LoadUserColumnSetup(ByRef frm As Form)
    Dim ctl As Control
    Dim strBlob As String
    Dim strColumns() As String
    Dim intColumns As Integer
    Dim intColumn As Integer
    Dim strValues() As String
    
    On Error Resume Next
    
    ' Only apply to forms in datasheet view.
    Const cDatasheetView As Long = 2
    If frm.CurrentView <> cDatasheetView Then Exit Sub
    
    strBlob = GetSetting("DB_Settings", "Settings", frm.Name, "")

    If strBlob <> "" Then
      Call GetOrderedColumns(strBlob, strColumns)
    
      intColumns = UBound(strColumns) + 1
      If intColumns <> 0 Then
        For intColumn = 0 To intColumns - 1
          If Trim(strColumns(intColumn)) <> "" Then
             strValues = Split(strColumns(intColumn), ":")
             Set ctl = frm.Controls(strValues(0))
             ctl.ColumnOrder = CInt(strValues(1))
             ctl.ColumnHidden = CBool(strValues(2))
             ctl.ColumnWidth = CLng(strValues(3))
          End If
        Next
      End If
    End If

End Sub
Public Sub SaveUserColumnSetup(ByRef frm As Form)
    Dim ctl As Control
    Dim strBlob As String
    Dim strCtl As String
    
    On Error Resume Next

    ' Only apply to forms in datasheet view.
    Const cDatasheetView As Long = 2
    If frm.CurrentView <> cDatasheetView Then Exit Sub
    
    For Each ctl In frm.Controls
      Select Case ctl.ControlType
        Case acLabel, acLine, acSubform, acCommandButton
            ' do nothing for these controls.
        Case Else
          strCtl = ctl.Name & ":" & _
                   ctl.ColumnOrder & ":" & _
                   ctl.ColumnHidden & ":" & _
                   ctl.ColumnWidth & vbCrLf
          strBlob = strBlob & strCtl
      End Select
    Next
    
    SaveSetting "DB_Settings", "Settings", frm.Name, strBlob

End Sub

